/*
based on material Copyright (C) 2011 Holtek Semiconductor Inc. All rights reserved
*/
/* Define to prevent recursive inclusion -------------------------------------------------------------------*/
#ifndef __HT32_USBD_CDCCLASS_H
#define __HT32_USBD_CDCCLASS_H

/* Includes ------------------------------------------------------------------------------------------------*/
#include "ht32_usbd_core.h"

/* Exported constants --------------------------------------------------------------------------------------*/

/* For ht32_usbd_descriptor.c                                                                               */
#define COMMUNICATION_INF_CLASS           (DESC_CLASS_02_CDC_CTRL)
#define COMMUNICATION_INF_SUBCLASS        (CDC_SUBCLASS_ABS)
#define COMMUNICATION_INF_PTCO            (CDC_PROTOCOL_AT)

#define DATA_INF_CLASS                    (DESC_CLASS_0A_CDC_DATA)
#define DATA_INF_SUBCLASS                 (CDC_SUBCLASS_NULL)
#define DATA_INF_PTCO                     (CDC_PROTOCOL_NULL)

/* CDC related definitions                                                                                   */
#define CDC_HEADER_LEN                    (0x05)
#define CDC_ABSTRACT_LEN                  (0x04)
#define CDC_UNION_LEN                     (0x05)
#define CDC_CALL_LEN                      (0x05)

#define CDC_TYPE_24_INF                   (0x24)

#define CDC_SUBTYPE_HEADER                (0x00)
#define CDC_SUBTYPE_CALL                  (0x01)
#define CDC_SUBTYPE_ABSTRACT              (0x02)
#define CDC_SUBTYPE_UNION                 (0x06)

#define CDC_SUBCLASS_NULL                 (0x00)
#define CDC_SUBCLASS_ABS                  (0x02)

#define CDC_PROTOCOL_NULL                 (0x00)
#define CDC_PROTOCOL_AT                   (0x01)

/* Exported types ------------------------------------------------------------------------------------------*/
typedef struct _VCP_LINE_CODING
{
  u32 dwDTERate;      //Bit rate;
  u8  bCharFormat;    //Stop bits:
                      //0 = 1   Stop bit
                      //1 = 1.5 Stop bit
                      //2 = 2   Stop bit
  u8  bParityType;    //parity:
                      //0 = None
                      //1 = Odd
                      //2 = Even
                      //3 = Mark
                      //4 = Space
  u8  bDataBits;      //Number of data bits (7,8,9)
}USBDCDCClass_LINE_CODING;

/* Exported variables --------------------------------------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------------------------------------*/
/* Exported functions --------------------------------------------------------------------------------------*/
void USBDCDCClass_Init(USBDCore_Class_TypeDef *pClass);
int CDCclass_send(u32 *buffer, int len);
int CDCclass_receive(u32 *buffer);

#endif /* __HT32_USBD_CLASS_H ------------------------------------------------------------------------------*/
